// ;-*-C++-*- *  Time-stamp: "2010-02-15 20:33:03 hmmr"
/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *
 * License: GPL
 *
 * Initial version: 2009-12-09
 */

#include "hosted-neurons.h"
#include "standalone-synapses.h"
#include "model.h"


int
main()
{
      // create and set up the model
	CModel *Model;
	if ( !(Model = new CModel( "test", new CIntegrateRK65(), 0)) ) {
		cerr << "Failed to create a model\n";
		return -1;
	}

      // add our three units
	CNeuronHH_d	*hh =
		new CNeuronHH_d( "HH", 0.2, 0.1, 0.3, Model, 0 | CN_UOWNED);  // meaning, it's our responsibility to delete this unit
	C_BaseNeuron	*pulse	 = static_cast<C_BaseNeuron*>(
		new COscillatorDotPoisson( "Pulse", 0.1, 0.2, 0.3, Model, 0)); // this one will be destroyed in ~CModel()
	CSynapseMxAB_dd	*synapse =
		new CSynapseMxAB_dd( "AB", pulse, hh, Model); // 0 is the default

      // enable_spikelogging_service
	hh -> enable_spikelogging_service();

	hh -> start_listening( CN_ULISTENING_DISK | CN_ULISTENING_1VARONLY);
	pulse -> start_listening( CN_ULISTENING_DISK);
	synapse -> start_listening( CN_ULISTENING_DISK);
//	Model->listen_dt = 0.;

      // set parameters
	synapse->param_value("gsyn") = 0.18;

      // go
	Model->advance( 100);


	delete Model;

	delete hh;

	return 0;
}


// EOF
